SDL_test_common.h
Go to the documentation of this file.
/*
Simple DirectMedia Layer
Copyright (C) 1997-2025 Sam Lantinga <slouken@libsdl.org>
This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any damages
arising from the use of this software.
Permission is granted to anyone to use this software for any purpose,
including commercial applications, and to alter it and redistribute it
freely, subject to the following restrictions:
1. The origin of this software must not be misrepresented; you must not
claim that you wrote the original software. If you use this software
in a product, an acknowledgment in the product documentation would be
appreciated but is not required.
2. Altered source versions must be plainly marked as such, and must not be
misrepresented as being the original software.
3. This notice may not be removed or altered from any source distribution.
*/
/*
* \file SDL_test_common.h
*
* Include file for SDL test framework.
*
* This code is a part of the SDL2_test library, not the main SDL library.
*/
/* Ported from original test\common.h file. */
#ifndef SDL_test_common_h_
#define SDL_test_common_h_
#include "SDL.h"
#if defined(__PSP__)
#define DEFAULT_WINDOW_WIDTH 480
#define DEFAULT_WINDOW_HEIGHT 272
#elif defined(__VITA__)
#define DEFAULT_WINDOW_WIDTH 960
#define DEFAULT_WINDOW_HEIGHT 544
#else
#define DEFAULT_WINDOW_WIDTH 640
#define DEFAULT_WINDOW_HEIGHT 480
#endif
#define VERBOSE_VIDEO 0x00000001
#define VERBOSE_MODES 0x00000002
#define VERBOSE_RENDER 0x00000004
#define VERBOSE_EVENT 0x00000008
#define VERBOSE_AUDIO 0x00000010
#define VERBOSE_MOTION 0x00000020
typedef struct
{
/* SDL init flags */
char **argv;
Uint32 flags;
Uint32 verbose;
/* Video info */
const char *videodriver;
int display;
const char *window_title;
const char *window_icon;
Uint32 window_flags;
SDL_bool flash_on_focus_loss;
int window_x;
int window_y;
int window_w;
int window_h;
int window_minW;
int window_minH;
int window_maxW;
int window_maxH;
int logical_w;
int logical_h;
float scale;
int depth;
int refresh_rate;
int num_windows;
SDL_Window **windows;
/* Renderer info */
const char *renderdriver;
Uint32 render_flags;
SDL_bool skip_renderer;
SDL_Renderer **renderers;
SDL_Texture **targets;
/* Audio info */
const char *audiodriver;
SDL_AudioSpec audiospec;
/* GL settings */
int gl_red_size;
int gl_green_size;
int gl_blue_size;
int gl_alpha_size;
int gl_buffer_size;
int gl_depth_size;
int gl_stencil_size;
int gl_double_buffer;
int gl_accum_red_size;
int gl_accum_green_size;
int gl_accum_blue_size;
int gl_accum_alpha_size;
int gl_stereo;
int gl_multisamplebuffers;
int gl_multisamplesamples;
int gl_retained_backing;
int gl_accelerated;
int gl_major_version;
int gl_minor_version;
int gl_debug;
int gl_profile_mask;
/* Additional fields added in 2.0.18 */
SDL_Rect confine;
} SDLTest_CommonState;
#include "begin_code.h"
/* Set up for C function definitions, even when using C++ */
#ifdef __cplusplus
extern "C" {
#endif
/* Function prototypes */
/*
* \brief Parse command line parameters and create common state.
*
* \param argv Array of command line parameters
* \param flags Flags indicating which subsystem to initialize (i.e. SDL_INIT_VIDEO | SDL_INIT_AUDIO)
*
* \returns a newly allocated common state object.
*/
SDLTest_CommonState *SDLTest_CommonCreateState(char **argv, Uint32 flags);
/*
* \brief Process one common argument.
*
* \param state The common state describing the test window to create.
* \param index The index of the argument to process in argv[].
*
* \returns the number of arguments processed (i.e. 1 for --fullscreen, 2 for --video [videodriver], or -1 on error.
*/
int SDLTest_CommonArg(SDLTest_CommonState * state, int index);
/*
* \brief Logs command line usage info.
*
* This logs the appropriate command line options for the subsystems in use
* plus other common options, and then any application-specific options.
* This uses the SDL_Log() function and splits up output to be friendly to
* 80-character-wide terminals.
*
* \param state The common state describing the test window for the app.
* \param argv0 argv[0], as passed to main/SDL_main.
* \param options an array of strings for application specific options. The last element of the array should be NULL.
*/
void SDLTest_CommonLogUsage(SDLTest_CommonState * state, const char *argv0, const char **options);
/*
* \brief Returns common usage information
*
* You should (probably) be using SDLTest_CommonLogUsage() instead, but this
* function remains for binary compatibility. Strings returned from this
* function are valid until SDLTest_CommonQuit() is called, in which case
* those strings' memory is freed and can no longer be used.
*
* \param state The common state describing the test window to create.
* \returns a string with usage information
*/
const char *SDLTest_CommonUsage(SDLTest_CommonState * state);
/*
* \brief Open test window.
*
* \param state The common state describing the test window to create.
*
* \returns SDL_TRUE if initialization succeeded, false otherwise
*/
SDL_bool SDLTest_CommonInit(SDLTest_CommonState * state);
/*
* \brief Easy argument handling when test app doesn't need any custom args.
*
* \param state The common state describing the test window to create.
* \param argc argc, as supplied to SDL_main
* \param argv argv, as supplied to SDL_main
*
* \returns SDL_FALSE if app should quit, true otherwise.
*/
SDL_bool SDLTest_CommonDefaultArgs(SDLTest_CommonState * state, const int argc, char **argv);
/*
* \brief Common event handler for test windows.
*
* \param state The common state used to create test window.
* \param event The event to handle.
* \param done Flag indicating we are done.
*
*/
void SDLTest_CommonEvent(SDLTest_CommonState * state, SDL_Event * event, int *done);
/*
* \brief Close test window.
*
* \param state The common state used to create test window.
*
*/
void SDLTest_CommonQuit(SDLTest_CommonState * state);
/*
* \brief Draws various window information (position, size, etc.) to the renderer.
*
* \param renderer The renderer to draw to.
* \param window The window whose information should be displayed.
* \param usedHeight Returns the height used, so the caller can draw more below.
*
*/
void SDLTest_CommonDrawWindowInfo(SDL_Renderer * renderer, SDL_Window * window, int * usedHeight);
/* Ends C function definitions when using C++ */
#ifdef __cplusplus
}
#endif
#include "close_code.h"
#endif /* SDL_test_common_h_ */
/* vi: set ts=4 sw=4 expandtab: */
SDL.h
SDL_Texture
struct SDL_Texture SDL_Texture
Definition SDL_render.h:149
SDL_Renderer
struct SDL_Renderer SDL_Renderer
Definition SDL_render.h:143
SDL_bool
SDL_bool
Definition SDL_stdinc.h:187
Uint32
uint32_t Uint32
Definition SDL_stdinc.h:231
SDLTest_CommonQuit
void SDLTest_CommonQuit(SDLTest_CommonState *state)
SDLTest_CommonDrawWindowInfo
void SDLTest_CommonDrawWindowInfo(SDL_Renderer *renderer, SDL_Window *window, int *usedHeight)
SDLTest_CommonDefaultArgs
SDL_bool SDLTest_CommonDefaultArgs(SDLTest_CommonState *state, const int argc, char **argv)
SDLTest_CommonCreateState
SDLTest_CommonState * SDLTest_CommonCreateState(char **argv, Uint32 flags)
SDLTest_CommonEvent
void SDLTest_CommonEvent(SDLTest_CommonState *state, SDL_Event *event, int *done)
SDLTest_CommonArg
int SDLTest_CommonArg(SDLTest_CommonState *state, int index)
SDLTest_CommonInit
SDL_bool SDLTest_CommonInit(SDLTest_CommonState *state)
SDLTest_CommonLogUsage
void SDLTest_CommonLogUsage(SDLTest_CommonState *state, const char *argv0, const char **options)
SDLTest_CommonUsage
const char * SDLTest_CommonUsage(SDLTest_CommonState *state)
SDL_Window
struct SDL_Window SDL_Window
Definition SDL_video.h:95
begin_code.h
close_code.h
SDL_AudioSpec
Definition SDL_audio.h:178
SDL_Rect
Definition SDL_rect.h:79
SDLTest_CommonState
Definition SDL_test_common.h:56
SDLTest_CommonState::gl_multisamplebuffers
int gl_multisamplebuffers
Definition SDL_test_common.h:110
SDLTest_CommonState::windows
SDL_Window ** windows
Definition SDL_test_common.h:83
SDLTest_CommonState::window_maxH
int window_maxH
Definition SDL_test_common.h:76
SDLTest_CommonState::window_y
int window_y
Definition SDL_test_common.h:70
SDLTest_CommonState::gl_debug
int gl_debug
Definition SDL_test_common.h:116
SDLTest_CommonState::gl_alpha_size
int gl_alpha_size
Definition SDL_test_common.h:100
SDLTest_CommonState::gl_accelerated
int gl_accelerated
Definition SDL_test_common.h:113
SDLTest_CommonState::audiospec
SDL_AudioSpec audiospec
Definition SDL_test_common.h:94
SDLTest_CommonState::gl_red_size
int gl_red_size
Definition SDL_test_common.h:97
SDLTest_CommonState::window_minW
int window_minW
Definition SDL_test_common.h:73
SDLTest_CommonState::gl_stereo
int gl_stereo
Definition SDL_test_common.h:109
SDLTest_CommonState::gl_accum_blue_size
int gl_accum_blue_size
Definition SDL_test_common.h:107
SDLTest_CommonState::targets
SDL_Texture ** targets
Definition SDL_test_common.h:90
SDLTest_CommonState::skip_renderer
SDL_bool skip_renderer
Definition SDL_test_common.h:88
SDLTest_CommonState::gl_accum_green_size
int gl_accum_green_size
Definition SDL_test_common.h:106
SDLTest_CommonState::num_windows
int num_windows
Definition SDL_test_common.h:82
SDLTest_CommonState::confine
SDL_Rect confine
Definition SDL_test_common.h:120
SDLTest_CommonState::window_x
int window_x
Definition SDL_test_common.h:69
SDLTest_CommonState::gl_minor_version
int gl_minor_version
Definition SDL_test_common.h:115
SDLTest_CommonState::gl_retained_backing
int gl_retained_backing
Definition SDL_test_common.h:112
SDLTest_CommonState::depth
int depth
Definition SDL_test_common.h:80
SDLTest_CommonState::argv
char ** argv
Definition SDL_test_common.h:58
SDLTest_CommonState::gl_green_size
int gl_green_size
Definition SDL_test_common.h:98
SDLTest_CommonState::render_flags
Uint32 render_flags
Definition SDL_test_common.h:87
SDLTest_CommonState::gl_double_buffer
int gl_double_buffer
Definition SDL_test_common.h:104
SDLTest_CommonState::gl_major_version
int gl_major_version
Definition SDL_test_common.h:114
SDLTest_CommonState::refresh_rate
int refresh_rate
Definition SDL_test_common.h:81
SDLTest_CommonState::gl_buffer_size
int gl_buffer_size
Definition SDL_test_common.h:101
SDLTest_CommonState::window_title
const char * window_title
Definition SDL_test_common.h:65
SDLTest_CommonState::logical_w
int logical_w
Definition SDL_test_common.h:77
SDLTest_CommonState::window_minH
int window_minH
Definition SDL_test_common.h:74
SDLTest_CommonState::window_h
int window_h
Definition SDL_test_common.h:72
SDLTest_CommonState::gl_multisamplesamples
int gl_multisamplesamples
Definition SDL_test_common.h:111
SDLTest_CommonState::flags
Uint32 flags
Definition SDL_test_common.h:59
SDLTest_CommonState::gl_depth_size
int gl_depth_size
Definition SDL_test_common.h:102
SDLTest_CommonState::flash_on_focus_loss
SDL_bool flash_on_focus_loss
Definition SDL_test_common.h:68
SDLTest_CommonState::window_flags
Uint32 window_flags
Definition SDL_test_common.h:67
SDLTest_CommonState::gl_profile_mask
int gl_profile_mask
Definition SDL_test_common.h:117
SDLTest_CommonState::verbose
Uint32 verbose
Definition SDL_test_common.h:60
SDLTest_CommonState::videodriver
const char * videodriver
Definition SDL_test_common.h:63
SDLTest_CommonState::gl_accum_alpha_size
int gl_accum_alpha_size
Definition SDL_test_common.h:108
SDLTest_CommonState::window_icon
const char * window_icon
Definition SDL_test_common.h:66
SDLTest_CommonState::window_maxW
int window_maxW
Definition SDL_test_common.h:75
SDLTest_CommonState::scale
float scale
Definition SDL_test_common.h:79
SDLTest_CommonState::renderdriver
const char * renderdriver
Definition SDL_test_common.h:86
SDLTest_CommonState::window_w
int window_w
Definition SDL_test_common.h:71
SDLTest_CommonState::display
int display
Definition SDL_test_common.h:64
SDLTest_CommonState::audiodriver
const char * audiodriver
Definition SDL_test_common.h:93
SDLTest_CommonState::gl_accum_red_size
int gl_accum_red_size
Definition SDL_test_common.h:105
SDLTest_CommonState::renderers
SDL_Renderer ** renderers
Definition SDL_test_common.h:89
SDLTest_CommonState::gl_stencil_size
int gl_stencil_size
Definition SDL_test_common.h:103
SDLTest_CommonState::logical_h
int logical_h
Definition SDL_test_common.h:78
SDLTest_CommonState::gl_blue_size
int gl_blue_size
Definition SDL_test_common.h:99
SDL_Event
Definition SDL_events.h:656